local T, C, L, _ = unpack(select(2, ...))
if C.chat.enable ~= true then return end

----------------------------------------------------------------------------------------
--	Systems spam filter
----------------------------------------------------------------------------------------
if C.chat.filter == true then
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_SAY", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_YELL", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_AFK", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_DND", function() return true end)
	DUEL_WINNER_KNOCKOUT = ""
	DUEL_WINNER_RETREAT = ""
	DRUNK_MESSAGE_ITEM_OTHER1 = ""
	DRUNK_MESSAGE_ITEM_OTHER2 = ""
	DRUNK_MESSAGE_ITEM_OTHER3 = ""
	DRUNK_MESSAGE_ITEM_OTHER4 = ""
	DRUNK_MESSAGE_OTHER1 = ""
	DRUNK_MESSAGE_OTHER2 = ""
	DRUNK_MESSAGE_OTHER3 = ""
	DRUNK_MESSAGE_OTHER4 = ""
	DRUNK_MESSAGE_ITEM_SELF1 = ""
	DRUNK_MESSAGE_ITEM_SELF2 = ""
	DRUNK_MESSAGE_ITEM_SELF3 = ""
	DRUNK_MESSAGE_ITEM_SELF4 = ""
	DRUNK_MESSAGE_SELF1 = ""
	DRUNK_MESSAGE_SELF2 = ""
	DRUNK_MESSAGE_SELF3 = ""
	DRUNK_MESSAGE_SELF4 = ""
	ERR_PET_LEARN_ABILITY_S = ""
	ERR_PET_LEARN_SPELL_S = ""
	ERR_PET_SPELL_UNLEARNED_S = ""
	ERR_LEARN_ABILITY_S = ""
	ERR_LEARN_SPELL_S = ""
	ERR_LEARN_PASSIVE_S = ""
	ERR_SPELL_UNLEARNED_S = ""
	CREATED_ITEM = ""
	CREATED_ITEM_MULTIPLE = ""

	-- Prevent empty line
	local function systemFilter(_, _, text)
		if text and text == "" then
			return true
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", systemFilter)
end

----------------------------------------------------------------------------------------
--	Players spam filter(by Evl, Elv22 and Affli)
----------------------------------------------------------------------------------------
if C.chat.spam == true then
	-- Repeat spam filter
	local strbyte, strsub, strsplit, strtrim, strfind, strmatch, gsub = string.byte, string.sub, string.split, string.trim, string.find, string.match, string.gsub
	local NameHash = {}
	local MSGCache = {}
	local RepInterval = 40
	local repeated_check_min = 0
	if GetLocale() == 'zhCN' or GetLocale() == 'zhTW' or GetLocale() == 'koKR' then
		repeated_check_min = 3 * 4;
	elseif L.Locale == 'enUS' or L.Locale == 'enGB' then
		repeated_check_min = 1 * 8;
	else
		repeated_check_min = 2 * 6;
	end
	local repeated_check_len = repeated_check_min * 2;
	local function UpdateCache()
		local dead = time() - RepInterval;
		for msg, cache in next, MSGCache do
			if cache[3] ~= true and cache[1] <= dead then
				MSGCache[msg] = nil;
			end
		end
		C_Timer.After(1.0, UpdateCache);
	end
	local RepCache = CreateFrame("Frame")
	RepCache:RegisterEvent("PLAYER_ENTERING_WORLD")
	RepCache:SetScript("OnEvent", UpdateCache)

	local function CutRepeatedSentence(msg, sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...)
		local len = #msg;
		if len > repeated_check_len then
			local new = msg;
			local n = len * 0.5 / repeated_check_min;
			n = n - n % 1.0;
			local count = 0;
			while n >= 1 do
				local cut = nil;
				local start = repeated_check_min * n;
				for i = start, start + 7 do
					--	ASCII	0xxx xxxx
					--	UTF-8	11xx xxxx 1xxx xxxx
					--	UTF-8	111x xxxx 1xxx xxxx 1xxx xxxx
					--	UTF-8	...
					local c = strbyte(new, i, i);
					if c < 0x80 then		--	1000 0000
						cut = i;
						break;
					elseif c > 0xc0 then	--	1100 0000
						cut = i -1;
						break;
					end
				end
				if cut ~= nil then
					local pat = gsub(strsub(new, 1, cut), "[%^%$%%%.%+%-%*%?%[%]%(%)]", "%%%1");
					local pos = strfind(new, pat, cut + 1);
					local temp1, temp2;
					if pos ~= nil then
						local single = strtrim(strsub(new, 1, pos - 1));
						pat = gsub(single, "[%^%$%%%.%+%-%*%?%[%]%(%)]", "%%%1");
						temp1, temp2 = gsub(new, pat, "");
						if temp2 > 1 then
							temp1 = strtrim(temp1);
							if strmatch(single, gsub(temp1, "[%^%$%%%.%+%-%*%?%[%]%(%)]", "%%%1")) then
								new = single;
							else
								new = single .. temp1;
							end
							local cache = MSGCache[new];
							if cache ~= nil then
								if cache[3] then
									MSGCache[msg] = { cache[1], line, true, sender, };
								else
									MSGCache[msg] = { cache[1], line, false, sender, nil, true, };
								end
								return true;
							end
							len = #new;
							if len <= repeated_check_len then
								break;
							end
							n = len / repeated_check_min;
							n = n - n % 1.0;
						end
					end
					count = count + 1;
					if count > 7 then
						break;
					end
				end
				n = n * 0.5;
				n = n - n % 1.0;
			end
			if new ~= msg then
				return false, new;
			else
				return false;
			end
		end
		return false;
	end
	local function ChatMessageFilter(self, event, msg, sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...)
		sender = Ambiguate(sender, 'none')
		if sender == T.name then
			return false
		end
		if arg6 == "DND" then
    		return true
    	end
		if NameHash[sender] then
			return true
		end
		--msg = gsub(msg, "((.)%2%2%2)", "");
		msg = strtrim(msg);
		local cache = MSGCache[msg];
		if cache ~= nil then
			if cache[3] or cache[6] then
				return true;
			else
				if RepInterval > 0 and cache[2] ~= line then
					cache[6] = true;	--	上一条消息的事件在这一条消息的事件前，已经处理完毕
					return true;
				elseif cache[5] ~= nil then
					return false, cache[5], sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...;
				else
					return false;
				end
			end
		end
		if #T.ChatBlockList > 0 then
			for index = 1, #T.ChatBlockList do
				if strmatch(sender, T.ChatBlockList[index]) ~= nil then
					NameHash[sender] = true;
					return true;
				end
			end
		end
		if #T.ChatSpamList > 0 then
			for index = 1, #T.ChatSpamList do
				if strmatch(msg, T.ChatSpamList[index]) ~= nil then
					MSGCache[msg] = { time(), line, true, sender, };
					return true;
				elseif strmatch(sender, T.ChatSpamList[index]) ~= nil then
					NameHash[sender] = true;
					return true;
				end
			end
		end
		--[=[		--	导致长度很短的消息一直被其他消息包含一直被过滤
		if RepInterval > 0 then
			local m1 = gsub(msg, "[%^%$%%%.%+%-%*%?%[%]%(%)]", "");
			for m2, cache in next, MSGCache do
				if strmatch(m2, m1) then
					MSGCache[msg] = { time(), line, false, sender, nil, true, };
					return true;
				end
			end
		end
		--]=]
		local filtered, new = CutRepeatedSentence(msg, sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...);
		if filtered then
			return true;
		end
		if new ~= nil then
			MSGCache[msg] = { time(), line, false, sender, new, };
			MSGCache[new] = { time(), line, false, sender, };
			return false, new, sender, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, line, arg12, arg13, arg14, ...;
		end
		MSGCache[msg] = { time(), line, false, sender, };
		return false;
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ChatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ChatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ChatMessageFilter)
	
	if IsAddOnLoaded("ShestakUI_Config") then
		local UnitPopupButtonsExtra = {
	    	["BLOCK"] = { enUS ="Block player",zhCN = "加入屏蔽名单",zhTW = "加入屏蔽名单" },
		}

		for k, v in pairs(UnitPopupButtonsExtra) do
	    	v.text = v[T.client] or k
	    	UnitPopupButtons[k] = v
		end

		tinsert(UnitPopupMenus["FRIEND"], 9, "BLOCK")

		hooksecurefunc("UnitPopup_OnClick", function(self)
	    	local name = UIDROPDOWNMENU_INIT_MENU.name
	    	local IGNORE = format(ERR_IGNORE_ADDED_S,name)
	    	if (self.value == "BLOCK") then
			    if not C.options["chat"] then
					C.options["chat"] = {}
				end	
				if not C.options["chat"]["ChatBlock_list"] then
					C.options["chat"]["ChatBlock_list"] = T.ChatBlockList
				end	
	        	table.insert(C.options.chat.ChatBlock_list, name)
	        	SendSystemMessage(IGNORE)
	    	end
		end)
	end
end
